<?php
/* 
Plugin Name: WoW Guild Retrieve
Plugin URI: http://www.manatrance.com/
Description: Shows the DFB Guild Data
Version: 0.9.0
Author: Ben Overmyer
Author URI: http://www.manatrance.com/
*/  

add_action('admin_menu', 'wow_guild_retrieve_options_menu');

wp_enqueue_script('newscript',
'/wp-content/plugins/wow-guild/js/jquery.tablesorter.min.js',
array('jquery') );

function wow_guild_retrieve_options_menu() {
	add_options_page('WoW Guild Retrieve Options', 'WoW Guild Retrieve', 8, __FILE__, 'WGR_options');
}

function WGR_options() {
	$var_realm = 'wgr_realm_name';
	$var_guild = 'wgr_guild_name';
	$var_region = 'wgr_region';
    $hidden_field_name = 'wgr_submit_hidden';
    $realm_field = 'wgr_realm_name';
	$guild_field = 'wgr_guild_name';
	$region_field = 'wgr_region';

    // Read in existing option value from database
    $realm_val = get_option( $var_realm );
	$guild_val = get_option( $var_guild );
	$region_val = get_option( $var_region );

    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( $_POST[ $hidden_field_name ] == 'Y' ) {
        // Read their posted value
		$realm_val = $_POST[ $realm_field ];
		$guild_val = $_POST[ $guild_field ];
		$region_val = $_POST[ $region_field ];

        // Save the posted value in the database
		update_option( $var_realm, $realm_val );
		update_option( $var_guild, $guild_val );
		update_option( $var_region, $region_val );

        // Put an options updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Options saved.', 'wgr_trans_domain' ); ?></strong></p></div>
<?php

    }

    // Now display the options editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" . __( 'WoW Guild Retrieve Plugin Options', 'wgr_trans_domain' ) . "</h2>";

    // options form
    
    ?>

<form name="form1" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">

<p><?php _e("Realm Name:", 'wgr_trans_domain' ); ?> 
<input type="text" name="<?php echo $realm_field; ?>" value="<?php echo $realm_val; ?>" size="20">
</p>

<p><?php _e("Guild Name:", 'wgr_trans_domain' ); ?> 
<input type="text" name="<?php echo $guild_field; ?>" value="<?php echo $guild_val; ?>" size="20">
</p>

<p><?php _e("Region:", 'wgr_trans_domain' ); ?> 
<input type="text" name="<?php echo $region_field; ?>" value="<?php echo $region_val; ?>" size="20">
</p>

<hr />

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Update Options', 'wgr_trans_domain' ) ?>" />
</p>

</form>
</div>

<?php

}

function buildURL($guild,$realm,$region) {
	$url = "";
	
	$guild = str_replace(' ','+',$guild);
	$realm = str_replace(' ','+',$realm);
	
	if ($region = 'us') {
		$url = 'http://www.wowarmory.com/guild-info.xml';
	} else {
		$url = 'http://eu.wowarmory.com/guild-info.xml';
	}
	
	$url .= '?r=' . $realm . '&n=' . $guild . '&p=1';
	
	return $url;
}

function wow_guild_retrieve() {
	$guild_name = get_option( 'wgr_guild_name' );
	$realm_name = get_option( 'wgr_realm_name' );
	$region = get_option ( 'wgr_region' );
	
    $url = buildURL($guild_name,$realm_name,$region);

	$ch = curl_init($url);
	
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.3) Gecko/20070309 Firefox/2.0.0.3");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$output = curl_exec($ch);
	curl_close($ch);

	$parser = xml_parser_create();
	xml_parse_into_struct($parser, $output,$vals,$index);
	xml_parser_free($parser);

	if (!$index) {
		echo "Unable to contact Armory.";
	} else {
		echo '<script type="text/javascript">';
		echo 'jQuery(document).ready(function() ';
		echo '{'; 
        echo 'jQuery("#guildinfo").tablesorter();';
		echo '}'; 
		echo ');';
		echo '</script>';
		echo "<table id='guildinfo'>";
		echo "<thead><tr><th>Name</th><th>Race</th><th>Class</th><th>Level</th></tr></thead>";
		echo "<tbody>";
		
		$whichrow = 0;
		
		foreach($index["CHARACTER"] as $characters) {
			$character = $vals[$characters]["attributes"];
			if ($whichrow == 0) {
				$rowstyle = "odd";
			} else {
				$rowstyle = "even";
			}
			echo "<tr class='$rowstyle'>";
			echo "<td class='nametd'><a href='http://" . $region . ".wowarmory.com/character-sheet.xml?" . $character["URL"] . "'>" . $character["NAME"] . "</a></td><td>" . $character["RACE"] . "</td><td>" . $character["CLASS"] . "</td><td>" . $character["LEVEL"] . "</td></tr>";
			echo "</tr>";
			$whichrow++;
			if ($whichrow >= 2) {
				$whichrow = 0;
			}
		}
		echo "</tbody>";
		echo "</table>";
	
	}
}

function check_guild($the_content) {
	
	$mystring = "get_guild_info";
	
	$pos = strpos($the_content, $mystring);
	
	if ($pos !== FALSE) {
		wow_guild_retrieve();
		$the_content = str_replace('get_guild_info','',$the_content);
	}
	
	return $the_content;
}

add_filter('the_content', 'check_guild');

?>